#include <iostream>
#include <string>
#include <vector>

struct Point {
    double x, y;
};

struct Polygon {
    std::vector<Point> vertices;
};

// Function taking struct as parameter
double distanceBetweenPoints(const Point& p1, const Point& p2) {
    double dx = p2.x - p1.x;
    double dy = p2.y - p1.y;
    return std::sqrt(dx*dx + dy*dy);
}

// Function returning struct
Point midpoint(const Point& p1, const Point& p2) {
    return {(p1.x + p2.x) / 2, (p1.y + p2.y) / 2};
}

int main() {
    Point a = {0, 0};
    Point b = {3, 4};

    std::cout << "Distance: " << distanceBetweenPoints(a, b) << std::endl;

    Point mid = midpoint(a, b);
    std::cout << "Midpoint: (" << mid.x << ", " << mid.y << ")" << std::endl;

    Polygon triangle;
    triangle.vertices = {{0, 0}, {1, 0}, {0, 1}};

    std::cout << "Triangle vertices:" << std::endl;
    for (const auto& vertex : triangle.vertices) {
        std::cout << "(" << vertex.x << ", " << vertex.y << ")" << std::endl;
    }

    return 0;
}
